<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %><%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %><%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %><%@ taglib prefix="w" uri="/web4j" %><%@ taglib prefix="tags" tagdir="/WEB-INF/tags" %>
<w:saveToFile named='${w:asType(feature.name)}Action.java'>
package ${feature.packageName};

import hirondelle.web4j.action.ActionTemplateListAndEdit;
import hirondelle.web4j.action.ResponsePage;
import hirondelle.web4j.database.DAOException;
import hirondelle.web4j.database.DuplicateException;
import hirondelle.web4j.database.SqlId;
import hirondelle.web4j.model.ModelCtorException;
import hirondelle.web4j.model.ModelFromRequest;
import hirondelle.web4j.request.RequestParameter;
import hirondelle.web4j.request.RequestParser;
import ${TemplatedPageClass};

/**
* List and edit ${feature.name} objects.
*/
public final class ${w:asType(feature.name)}Action extends ActionTemplateListAndEdit {

  /** Constructor.  */
  public ${w:asType(feature.name)}Action(RequestParser aRequestParser){
    super(FORWARD, REDIRECT_TO_LISTING, aRequestParser);
  }
  
  public static final SqlId LIST_${w:asConstant(feature.name)}S =  new SqlId("LIST_${w:asConstant(feature.name)}S");
  public static final SqlId FETCH_${w:asConstant(feature.name)} =  new SqlId("FETCH_${w:asConstant(feature.name)}");
  public static final SqlId ADD_${w:asConstant(feature.name)} =  new SqlId("ADD_${w:asConstant(feature.name)}");
  public static final SqlId CHANGE_${w:asConstant(feature.name)} =  new SqlId("CHANGE_${w:asConstant(feature.name)}");
  public static final SqlId DELETE_${w:asConstant(feature.name)} =  new SqlId("DELETE_${w:asConstant(feature.name)}");

  <c:forEach var='field' items='${fields}'>public static final RequestParameter ${w:asConstant(field.name)} = RequestParameter.<c:if test='${field.isHardValidatedForLength}'>withLengthCheck("${w:asType(field.name)}");</c:if><c:if test='${not field.isHardValidatedForLength}'>withRegexCheck("${w:asType(field.name)}", "${field.hardValidationPattern}");</c:if>
  </c:forEach>
  protected void doList() throws DAOException {
    addToRequest(ITEMS_FOR_LISTING, fDAO.list());
  }
  
  protected void validateUserInput() {
    try {
      ModelFromRequest builder = new ModelFromRequest(getRequestParser());
      ${w:asField(feature.name)} = builder.build(${w:asType(feature.name)}.class, <w:noLastComma><c:forEach var='field' items='${fields}'>${w:asConstant(field.name)}, </c:forEach></w:noLastComma>);
    }
    catch (ModelCtorException ex){
      addError(ex);
    }    
  }
  
  protected void attemptAdd() throws DAOException {
    try {
      ${w:asField('DAO')}.add(${w:asField(feature.name)});
      addMessage("${feature.name} added successfully.");
    }
    catch(DuplicateException ex){
      addError("Cannot add duplicate ${feature.name}.");  
    }
  }
  
  protected void attemptFetchForChange() throws DAOException {
    ${w:asType(feature.name)} ${w:asLocal(feature.name)} = ${w:asField('DAO')}.fetch(getIdParam(${primaryKey}));
    if( ${w:asLocal(feature.name)} == null ){
      addError("Item no longer exists. Likely deleted by another user.");
    }
    else {
      addToRequest(ITEM_FOR_EDIT, ${w:asLocal(feature.name)});
    }
  }
  
  protected void attemptChange() throws DAOException {
    try {
      boolean success = ${w:asField('DAO')}.change(${w:asField(feature.name)});
      if (success){
        addMessage("${feature.name} changed successfully.");
      }
      else {
        addError("No update occurred. Item likely deleted by another user.");
      }
    }
    catch(DuplicateException ex){
      addError("Duplicate ${feature.name}. Please use another identifier.");  
    }
  }
  
  protected void attemptDelete() throws DAOException {
    try {
      ${w:asField('DAO')}.delete(getIdParam(${primaryKey}));
      addMessage("${feature.name} deleted successfully.");
    }
    catch (DAOException ex){
      addError("Cannot delete ${feature.name}. Item likely used elsewhere.");      
    }
  }
  
  // PRIVATE //
  private ${w:asType(feature.name)} ${w:asField(feature.name)};
  private ${w:asType(feature.name)}DAO ${w:asField('DAO')} = new ${w:asType(feature.name)}DAO();
  private static final ResponsePage FORWARD = TemplatedPage.get("${feature.name}", "view.jsp", ${w:asType(feature.name)}Action.class);
  private static final ResponsePage REDIRECT_TO_LISTING = new ResponsePage("${w:asType(feature.name)}Action.do?Operation=List");
}
</w:saveToFile>