<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %> <%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %> <%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %> <%@ taglib prefix="w" uri="/web4j" %> <%@ taglib prefix="tags" tagdir="/WEB-INF/tags" %> 
<w:saveToFile named='${w:asType(feature.name)}DAO.java'>
package ${feature.packageName};

<c:if test='${feature.showOperation == "List"}'>import java.util.*;</c:if>
import hirondelle.web4j.database.DAOException;
import hirondelle.web4j.database.Db;
import hirondelle.web4j.database.DuplicateException;
import hirondelle.web4j.model.Id;
import static ${feature.packageName}.${w:asType(feature.name)}Action.${w:asConstant(feature.showOperation)}_${w:asConstant(feature.name)}<c:if test='${feature.showOperation == "List"}'>S</c:if>;
import static ${feature.packageName}.${w:asType(feature.name)}Action.${w:asConstant(feature.applyOperation)}_${w:asConstant(feature.name)};

/** 
* Data Access Object (DAO) for {@link ${w:asType(feature.name)}} objects. 
*/
final class ${w:asType(feature.name)}DAO {  

  <c:if test="${feature.showOperation == 'List'}">/** Return a <tt>List</tt> of all {@link ${w:asType(feature.name)}} objects.  */
  List<${w:asType(feature.name)}> list() throws DAOException {
    return Db.list(${w:asType(feature.name)}.class, LIST_${w:asConstant(feature.name)}S);
  }</c:if>
<c:if test="${feature.showOperation == 'Fetch'}">  /** Return a single {@link ${w:asType(feature.name)}} identified by its id.  */
  ${w:asType(feature.name)} fetch(Id ${w:asArgument(feature.name)}Id) throws DAOException {
    return Db.fetch(${w:asType(feature.name)}.class, FETCH_${w:asConstant(feature.name)}, ${w:asArgument(feature.name)}Id);
  }</c:if>  

<c:if test="${feature.applyOperation == 'Add'}">  /**
  * Add a new {@link ${w:asType(feature.name)}} to the database.
  * 
  * @return the autogenerated database id, if any.
  */
  Id add(${w:asType(feature.name)} ${w:asArgument(feature.name)}) throws DAOException, DuplicateException {
    Id result = Db.add(
      ADD_${w:asConstant(feature.name)}, 
      <w:noLastComma><c:forEach var='item' items='${fields}'><c:if test='${not item.isPrimaryKey}'>${w:asArgument(feature.name)}.get${w:asType(item.name)}(), </c:if></c:forEach></w:noLastComma>
    );
    return result;
  }</c:if> 
<c:if test="${feature.applyOperation == 'Change'}">  /** Update an existing {@link ${w:asType(feature.name)}}.  */
  boolean change(${w:asType(feature.name)} ${w:asArgument(feature.name)}) throws DAOException, DuplicateException {
    Object[] params = {<w:noLastComma><c:forEach var='item' items='${fields}'><c:if test='${not item.isPrimaryKey}'>${w:asArgument(feature.name)}.get${w:asType(item.name)}(), </c:if></c:forEach><c:forEach var='item' items='${fields}'><c:if test='${item.isPrimaryKey}'>${w:asArgument(feature.name)}.get${w:asType(item.name)}(), </c:if></c:forEach></w:noLastComma>};
    return Util.isSuccess(Db.edit(CHANGE_${w:asConstant(feature.name)}, params));
  }</c:if>  
<c:if test="${feature.applyOperation == 'Delete'}">  /**
  * Delete a {@link ${w:asType(feature.name)}}.
  * 
  * <P>If an item is linked to this {@link ${w:asType(feature.name)}}, then deletion will fail, and a 
  * {@link DAOException} is thrown.
  */
  void delete(Id ${w:asArgument(feature.name)}Id) throws DAOException {
    Db.delete(DELETE_${w:asConstant(feature.name)}, ${w:asArgument(feature.name)}Id);
  }</c:if>
}
</w:saveToFile>