<%-- Feature --%>
<%@ include file="/JspHeader.jsp" %>

<w:help>
<div class="help">
<w:txt wikiMarkup="true" translate="false">
  Edit the feature name, and style of user interaction. 
  Enter the feature name in natural looking text, such as 'Jet Engine'.
  
  The feature name is used to generate many other items: class names, file names, identifiers, and so on, 
  which are formatted according to context. See Functions class 
  for more details. To alter coding conventions for naming fields and so on, simply amend the 
  implementation of Functions.java. You may also amend the various view.jsp files, to alter presentation details.
  
  The UI (user interaction) style maps to an _ActionTemplateXXX_ base class.
  
  The package must be a correctly formed Java package name.
  
  This tool does not persist your input - it merely stores it in session scope.
  
  The source code of this tool is freely available, and you may alter it 
  to more closely match your needs.
</w:txt>
</div>
</w:help>

<c:url value="FeatureAction.do?Operation=Apply" var="baseURL"/> 
<form action='${baseURL}' method="post" class="user-input" name='giveMeFocus'>
 <w:populate using="itemForEdit">
 <table align="center">
  <tr>
   <td>
    <label>Feature Name</label> 
   </td>
   <td>
     <input type='text' name='Name'  maxlength='50'>
   </td>
  </tr>
  <tr>
   <td>
    <label>UI Style</label> 
   </td>
   <td>
    <select name='UiStyle'>
      <option></option>
      <c:forEach var='item' items='${UiStyle}'>
        <option value='${item}'>${item.forDisplay}</option>
      </c:forEach>
    </select>
   </td>
  </tr>
  <tr>
   <td>
    <label>Package Name</label> 
   </td>
   <td>
     <input type='text' name='PackageName'  maxlength='200' size='50'>
   </td>
  </tr>
  <tr>
   <td colspan='2'>&nbsp;</td>
  </tr>
  <tr>
   <td colspan='2'>For Show-and-Apply Style Only :</td>
  </tr>
  <tr>
   <td>
    <label title='Applies only to the Show-and-Apply UI style'>Show Operation</label> 
   </td>
   <td>
    <select name='ShowOperation'  title='Applies only to the Show-and-Apply UI style'>
      <option></option>
      <c:forEach var='item' items='${ShowOperation}'>
        <option value='${item}'>${item}</option>
      </c:forEach>
    </select>
   </td>
  </tr>
  <tr>
  <tr>
   <td>
    <label title='Applies only to the Show-and-Apply UI style'>Apply Operation</label> 
   </td>
   <td>
    <select name='ApplyOperation' title='Applies only to the Show-and-Apply UI style'>
      <option></option>
      <c:forEach var='item' items='${ApplyOperation}'>
        <option value='${item}'>${item}</option>
      </c:forEach>
    </select>
   </td>
  </tr>
  <tr>
 </w:populate>
 
  <tr>
   <td align="center" colspan=2>
    <input type="submit" value="Update">
   </td>
  </tr>
 </table>
</form>
