<%-- Parsed View of Log File --%>
<%@ include file="/JspHeader.jsp" %>
<w:help>
<div class="help">
<w:txt wikiMarkup="true" translate="false">
 View and query log content, using parsed versions of the underlying records.
 
 Using parsed records is usually preferred over viewing raw log files, since it allows for 
 more flexible querying. By default, the format of records is assumed to be that 
 emitted by default JDK loggers. If you are using some other format, you will need 
 to create a new implementation of the LogParser interface, and edit this tool's 
 underlying code.
 
 This tool uses a CSS class to control the display of each record according to Level.
 You can alter this display by changing the content of these CSS classes.
 
 This screens adds log numbers to each log record, as a convenience.
 These are temporary log numbers produced for each new listing.
</w:txt>
</div>
</w:help>

<c:url var='baseURI' value=''/>

<form action='${baseURI}' method='GET' class="user-input" name='giveMeFocus'>
<w:populate>
 <table align='center'>
  <tr>
   <td><label>Log For</label></td>
   <td><input type='radio' name='Log For' value='Application' checked>Application <input type='radio' name='Log For' value='Server'>Tomcat</td>
  </tr>
  <tr>
   <td><label>Level</label></td>
   <td>
     <select name='Level'>
      <option>SEVERE</option>
      <option>WARNING</option>
      <option>INFO</option>
      <option>CONFIG</option>
      <option>FINE</option>
      <option>FINER</option>
      <option>FINEST</option>
     </select>
     and above
   </td>
  </tr>
  <tr>
   <td><label>Min Date/Time</label></td>
   <td><input type='text' name='Min Date'  size='16' title='Format MMDDYYYY HH:MM:SS, with 24-hour time'> (12312007 13:59:59)</td>
  </tr>
  <tr>
   <td><label>Max Date/Time</label></td>
   <td><input type='text' name='Max Date'  size='16' title='Format MMDDYYYY HH:MM:SS, with 24-hour time'> (12312007 13:59:59)</td>
  </tr>
  <tr>
   <td><label>Logger Name Starts With</label></td>
   <td><input type='text' name='Logger Starts With'  size='40'></td>
  </tr>
  <tr>
   <td><label>Method Named</label></td>
   <td><input type='text' name='Method Name'  size='40'></td>
  </tr>
  <tr>
   <td><label>Log Message Contains</label></td>
   <td><input type='text' name='Message Contains' size='40'></td>
  </tr>
  <tr>
   <td><label>Reverse Order?</label></td>
   <td><input type='checkbox' name='Reverse Order' value='true'></td>
  </tr>
</w:populate>
  <tr>
    <td>&nbsp;</td>
    <td>
     <input type='submit' value="View Log">
     <input type='reset' >
     <input type="hidden" name="Operation" value="Search">
    </td>
   </tr>
  </table>
</form>

<%-- Display the log file content as parsed records. --%>
<P>
<c:if test='${not empty mostRecentLog}'>
File : <b>${mostRecentLog.absolutePath}</b> 
[<em><fmt:formatDate value='${mostRecentLogDate}'  pattern='yyyy-MM-dd HH:mm:ss'/> -  
<fmt:formatNumber value='${mostRecentLogSize}' pattern='#,##0'/> bytes</em>]<br>
</c:if>

<c:if test="${param.Operation == 'Search'}">
  Number of records matching the given criteria : ${fn:length(itemsForListing)}
 <hr>
</c:if>

<c:forEach var='item' items='${itemsForListing}' varStatus="index">
  <c:if test="${item.level eq 'SEVERE'}"><span class='log-severe'></c:if>
  <c:if test="${item.level eq 'WARNING'}"><span class='log-warning'></c:if>
  <c:if test="${item.level eq 'INFO'}"><span class='log-info'></c:if>
  <c:if test="${item.level eq 'CONFIG'}"><span class='log-config'></c:if>
  <c:if test="${item.level eq 'FINE'}"><span class='log-fine'></c:if>
  <c:if test="${item.level eq 'FINER'}"><span class='log-finer'></c:if>
  <c:if test="${item.level eq 'FINEST'}"><span class='log-finest'></c:if>
  <b>${index.count}</b>: <fmt:formatDate value='${item.date}' pattern='MMM d, yyyy h:mm:ss aaa'/> 
  ${item.level} 
  ${item.logger}: <em>${item.method}</em></span>
  <PRE class='log-message'>${item.message}</PRE>
  <hr class='log-separator'>
</c:forEach>

