package hirondelle.web4jtools.metrics.jars;

import hirondelle.web4j.action.ResponsePage;
import hirondelle.web4j.request.RequestParser;
import hirondelle.web4jtools.metrics.base.FileInfo;
import hirondelle.web4jtools.metrics.base.MetricsAction;

import java.util.ArrayList;
import java.util.List;

/**
* Display name and version for all jars in your source tree. 
*/
public final class JarsAction extends MetricsAction {
  
  public JarsAction(RequestParser aRequestParser){
    super(FORWARD, aRequestParser);
  }
  
  /**  Display name and version for all jar files found in your source tree.  */
  protected void calculateMetric() {
    addToRequest("jarFiles", filterJarFiles(fFileList));
  }
  
  // PRIVATE //
  private static final ResponsePage FORWARD = new ResponsePage("Name/Version of Jar Files", "view.jsp", JarsAction.class);
  
  private List<FileInfo> filterJarFiles(List<FileInfo> aFiles) {
    List<FileInfo> result = new ArrayList<FileInfo>();
    for(FileInfo fileInfo: aFiles){
      if( fileInfo.isJarFile() ) {
        result.add(fileInfo);
      }
    }
    return result;
  }
}