<%-- List Files With Tab Chars. --%>
<%@ include file="/JspHeader.jsp" %>
<w:help>
<div class="help">
<w:txt wikiMarkup="true" translate="false">
 Lists all source files containing one or more TAB characters.

TAB characters are often considered undesirable for source code, since 
tab characters are rendered in different ways by different tools. In particular, many 
text editors use a large number of spaces to represent a TAB character; this 
often makes source code difficult to read.

You should make a back up before attempting to remove all TAB characters.

The _Link_ is a valid URI, but your browser may not follow the link for security reasons. 
Simply copy the URI, and paste it directly into your browser's URI control.
</w:txt>
</div>
</w:help>


<P>
<table class="report" align="center"> 
 <tr><td><b>There are ${numTabs} TAB characters in your source code, spread over ${fn:length(filesWithTabs)} files.</td></tr>
</table>

<c:if test='${not empty filesWithTabs}'>
<P>
<c:url var='removeTabsURI' value='TabsRemoveAction.do'/>
<form action='${removeTabsURI}' method='POST'>
 <table align='center' class='report'>
  <tr>
   <td><b>WARNING</b> : this action will potentially make many edits across many files.<br>
    It is prudent to make a backup in case an error occurs.
   </td> 
  </tr>
   <tr>
    <td align='center'>
    <input type='submit' value='Remove all TAB characters'>
   </td>
  </tr>
 </table>
</form>

<P>
<table class="report" align="center"> 
 <tr>
   <th>Num TABs</th>
   <th>File</th>
   <th>Link</th>
 <c:forEach var='item' items='${filesWithTabs}'>
 <tr>
  <td align='right'>${item.numTabs}</td>
  <td style='font-size:70%;'>${item.name}</td>
  <td><c:url var='fileURI' value='${w:fileURL(item.name.rawString)}'/><a href='${fileURI}' title='Paste URI directly into address bar. Browser may not follow file:// URIs.'>link</a></td>
  </tr>
 </c:forEach>
</table>
</c:if>
