package hirondelle.web4jtools.util;

import hirondelle.web4j.util.Util;
import java.util.logging.*;

/**  Ensure an item is configured as expected in <tt>web.xml</tt>. */
public final class Ensure {

  /**
  * Ensure an item is configured as expected in <tt>web.xml</tt>.
  * 
  * If the item is absent, the fact is logged at <tt>SEVERE</tt> level, and a 
  * <tt>RuntimeException</tt> is thrown.
  */
  public static void isPresentInWebXml(String aParamName, String aParamValue){
    if ( ! Util.textHasContent(aParamValue) ) {
      String message = "In web.xml, please specify a value for parameter named " + Util.quote(aParamName);
      fLogger.severe(message);
      throw new RuntimeException(message);
    }
  }
  
  // PRIVATE //
  private static final Logger fLogger = Util.getLogger(Ensure.class);
}
