package hirondelle.web4jtools.util;

import hirondelle.web4j.action.ResponsePage;

/**
* Create templated {@link ResponsePage} objects.
* 
* <P><span class='highlight'>This implementation assumes that related JSPs and classes reside in 
* the same directory.</span> This policy is unusual, but recommended. Having <em>all</em> items 
* related to a feature in the same directory - classes, JSPs, and .sql files - is highly 
* satisfying and natural. 
*/
public final class TemplatedPage {
  
  /**
  * Return a templated page for displaying plain text, not markup.
  */
  public static ResponsePage getPlain(String aTitle, String aBodyJsp, Class aRepresentativeClass) {
    return new ResponsePage(aTitle, aBodyJsp, PLAIN, aRepresentativeClass);
  }
  
  // PRIVATE //
  
  private TemplatedPage(){}
  
  private static final String PLAIN = "../TemplatePlain.jsp";
}
